<?php
/**
 * @version		1.0
 * @package		Joomla
 * @subpackage	
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
class EventBookingHelper {
	/**
	 * Get configuration data and store in config object
	 *
	 * @return object
	 */
	function getConfig($nl2br = false) {
		static $config ;
		if (!$config) {
			$db = & JFactory::getDBO();
			$config = new stdClass ;
			$sql = 'SELECT * FROM #__eb_configs';
			$db->setQuery($sql);
			$rows = $db->loadObjectList();
			for ($i = 0 , $n = count($rows); $i < $n; $i++) {
				$row = $rows[$i];
				$key = $row->config_key;
				$value = stripslashes($row->config_value);
				if ($nl2br)
					$value = nl2br($value); 
				$config->$key = $value;	
			}
		}		
		return $config;
	}
	/**
	 * Get specify config value
	 *
	 * @param string $key
	 */
	function getConfigValue($key) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT config_value FROM #__eb_configs WHERE config_key="'.$key.'"';
		$db->setQuery($sql) ;
		return $db->loadResult();
	}	
	/**
	 * Get Itemid of Joom Donation
	 *
	 * @return int
	 */
	function getItemid() {
		$db = & JFactory::getDBO();
		$sql = "SELECT id FROM #__menu WHERE link LIKE '%index.php?option=com_eventbooking%' AND published=1 AND `access`=0";
		$db->setQuery($sql) ;
		$itemId = $db->loadResult();		
		if (!$itemId) {
			global $Itemid ;
			if ($Itemid == 1)
				$itemId = 999999 ;
			else 
				$itemId = $Itemid ;	
		}			
		return $itemId ;	
	}
	/**
	 * Load language from main component
	 *
	 */
	function loadLanguage() {
		static $loaded ;
		if (!$loaded) {
			$lang = & JFactory::getLanguage() ;
			$tag = $lang->getTag();
			if (!$tag)
				$tag = 'en-GB' ;			
			$lang->load('com_eventbooking', JPATH_ROOT, $tag);
			$loaded = true ;	
		}		
	}	
	/**
	 * Get email content. For [PAYMENT_DETAIL] tag
	 *
	 * @param object $config
	 * @param object $row
	 * @return string
	 */		
	function getEmailContent($config, $row) {
		global $Itemid ;
		jimport( 'joomla.application.component.view') ;
		$db = & JFactory::getDBO() ;			
		$viewConfig['name'] = 'form' ;
		$viewConfig['base_path'] = JPATH_ROOT.DS.'components'.DS.'com_eventbooking'.DS.'emailtemplates' ;
		$viewConfig['template_path'] = JPATH_ROOT.DS.'components'.DS.'com_eventbooking'.DS.'emailtemplates' ;		
		//We will need to check
		if ($config->multiple_booking) {
			$viewConfig['layout'] = 'cart' ;			
		} else {
			//Check to see whether this registration record
			$sql = 'SELECT COUNT(*) FROM #__eb_registrants WHERE group_id='.$row->id;
			$db->setQuery($sql) ;
			$total = $db->loadResult();			
			if ($total)			
				$viewConfig['layout'] = 'group_detail' ;
			else 
				$viewConfig['layout'] = 'individual_detail' ;
		}					
		$view =  new JView($viewConfig) ;				
		if ($config->multiple_booking) {
			$view->assignRef('config', $config) ;
			$view->assignRef('row', $row) ;
			$view->assignRef('Itemid', $Itemid) ;			
			$sql = 'SELECT a.*, b.event_date, b.title FROM #__eb_registrants AS a INNER JOIN #__eb_events AS b ON a.event_id=b.id WHERE a.id='.$row->id.' OR a.cart_id='.$row->id;
			$db->setQuery($sql) ;
			$rows = $db->loadObjectList() ;
			$sql = 'SELECT SUM(total_amount) FROM #__eb_registrants WHERE id='.$row->id.' OR cart_id='.$row->id;
			$db->setQuery($sql) ;
			$totalAmount = $db->loadResult();
			
			$sql = 'SELECT SUM(discount_amount) FROM #__eb_registrants WHERE id='.$row->id.' OR cart_id='.$row->id;
			$db->setQuery($sql) ;
			$discountAmount = $db->loadResult();			
			$amount = $totalAmount - $discountAmount ;
			$view->assignRef('discountAmount', $discountAmount) ;			
			$view->assignRef('totalAmount', $totalAmount) ;
			$view->assignRef('items', $rows) ; 
			$view->assignRef('amount', $amount) ;
		} else {
			$sql = 'SELECT event_date, title, params FROM #__eb_events WHERE id='.$row->event_id ;
			$db->setQuery($sql) ;
			$rowEvent = $db->loadObject();	
			//Override config			
			$params = new JParameter($rowEvent->params) ;
			$keys = array('s_lastname', 'r_lastname', 's_organization', 'r_organization', 's_address', 'r_address', 's_address2', 'r_address2', 's_city', 'r_city', 's_state', 'r_state', 's_zip', 'r_zip', 's_country', 'r_country', 's_phone', 'r_phone', 's_fax', 'r_fax', 's_comment', 'r_comment');				
			foreach ($keys as $key) {
				$config->$key = $params->get($key, 0) ;
			}		
			$keys = array('gr_lastname', 'gr_lastname', 'gs_organization', 'gr_organization', 'gs_address', 'gr_address', 'gs_address2', 'gr_address2', 'gs_city', 'gr_city', 'gs_state', 'gr_state', 'gs_zip', 'gr_zip', 'gs_country', 'gr_country', 'gs_phone', 'gr_phone', 'gs_fax', 'gr_fax', 'gs_email', 'gr_email', 'gs_comment', 'gr_comment');
			foreach ($keys as $key) {
				$config->$key = $params->get($key, 0) ;
			}
							
			$view->assignRef('rowEvent', $rowEvent) ;
			$view->assign('config', $config) ;
			$view->assignRef('row', $row) ;
			if ($row->number_registrants > 1) {
				$sql = 'SELECT * FROM #__eb_registrants WHERE group_id='.$row->id ;
				$db->setQuery($sql) ;
				$rowMembers = $db->loadObjectList();
				$view->assignRef('rowMembers', $rowMembers) ;							
			} else {
				$jcFields = new JCFields($row->event_id, false, 0) ;
				$view->assignRef('jcFields', $jcFields) ;	 
			}			
		}									
		ob_start();		
		$view->display() ;	
		$text = ob_get_contents() ;
		ob_end_clean();
		return $text ;			
	}		
	/**
	 * Build category dropdown
	 *
	 * @param int $selected
	 * @param string $name
	 * @param Boolean $onChange
	 * @return string
	 */
	function buildCategoryDropdown($selected, $name="parent", $onChange=true) {
		$db = & JFactory::getDBO();
		$sql = "SELECT id, parent, name FROM #__eb_categories";			
		$db->setQuery($sql);
		$rows = $db->loadObjectList();		
		$children = array();
		if ($rows)
		{
			// first pass - collect children
			foreach ( $rows as $v )
			{
				$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}					
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );				
		$options 	= array();
		$options[] 	= JHTML::_('select.option',  '0', JText::_( 'Top' ) );
		foreach ( $list as $item ) {
			$options[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename );
		}
		if ($onChange)
			$output = JHTML::_('select.genericlist',   $options, $name, 'class="inputbox" onchange="submit();" ', 'value', 'text', $selected );
		else
			$output = JHTML::_('select.genericlist',   $options, $name, 'class="inputbox" ', 'value', 'text', $selected );
		return $output;
	}	
	/**
	 * Parent category select list
	 *
	 * @param object $row
	 * @return void
	 */
	function parentCategories($row) {
		$db =& JFactory::getDBO();
		$sql = "SELECT id, parent, name FROM #__eb_categories";
		if ($row->id)
			$sql .= ' WHERE id != '.$row->id;				
		if (!$row->parent) {
			$row->parent = 0;
		}		
		$db->setQuery($sql);
		$rows = $db->loadObjectList();		
		$children = array();
		if ($rows)
		{
			// first pass - collect children
			foreach ( $rows as $v )
			{
				$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}			
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );
				
		$options 	= array();
		$options[] 	= JHTML::_('select.option',  '0', JText::_( 'Top' ) );
		foreach ( $list as $item ) {
			$options[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename );
		}
		$output = JHTML::_('select.genericlist',   $options, 'parent', 'class="inputbox"', 'value', 'text', $row->parent );
		return $output;
	}
	/**
	 * Get total document of a category
	 *
	 * @param int $categoryId
	 */
	function getTotalEvent($categoryId, $includeChildren = true) {
		$hidePastEvents = EventBookingHelper::getConfigValue('hide_past_events') ;
		$db = & JFactory::getDBO();
		$arrCats = array();
		$cats = array();
		$arrCats[] =  $categoryId;
		$cats[] = $categoryId;
		if ($includeChildren) {
			while (count($arrCats)) {
				$catId = array_pop($arrCats);
				//Get list of children category
				$sql  = 'SELECT id FROM #__eb_categories WHERE parent='.$catId.' AND published=1';
				$db->setQuery($sql);				
				$rows = $db->loadObjectList();
				for ($i = 0 , $n = count($rows); $i < $n; $i++) {
					$row = $rows[$i];
					$arrCats[] = $row->id;
					$cats[] = $row->id;
				}
			}	
		}
		if ($hidePastEvents) 
			$sql = 'SELECT COUNT(a.id) FROM #__eb_events AS a INNER JOIN #__eb_event_categories AS b ON a.id = b.event_id WHERE b.category_id IN('.implode(',', $cats).') AND published = 1 AND event_date >= NOW() ';
		else 
			$sql = 'SELECT COUNT(a.id) FROM #__eb_events AS a INNER JOIN #__eb_event_categories AS b ON a.id = b.event_id WHERE b.category_id IN('.implode(',', $cats).') AND published = 1 ';	
		$db->setQuery($sql);		
		$total = $db->loadResult();						
		return $total;			
	}
	/**
	 * Check to see whether this event still accept registration
	 *
	 * @param int $eventId
	 * @return Boolean
	 */
	function acceptRegistration($eventId) {
		$db = & JFactory::getDBO() ;
		$user = & JFactory::getUser() ;
		$gid = $user->get('aid');		
		if (!$eventId)
			return false ;		
		$sql = 'SELECT * FROM #__eb_events WHERE id='.$eventId.' AND published=1 ' ;		
		$db->setQuery($sql) ;
		$row = $db->loadObject();
		if (!$row)
			return false ;
		if ($row->registration_type == 3)
			return false ;	
		if ($row->cut_off_date == $db->getNullDate()) {
			$sql = 'SELECT DATEDIFF(NOW(), event_date) AS number_days FROM #__eb_events WHERE id='.$eventId ;				
		} else {
			$sql = 'SELECT DATEDIFF(NOW(), cut_off_date) AS number_days FROM #__eb_events WHERE id='.$eventId ;
		}
		if ($row->registration_access > $gid) {
			return false ;
		}
		$db->setQuery($sql) ;
		$numberDays = $db->loadResult();
		if ($numberDays > 0) {
			return false ;
		}
		if ($row->event_capacity) {
			//Get total registrants for this event
			$sql = 'SELECT SUM(number_registrants) AS total_registrants FROM #__eb_registrants WHERE event_id='.$eventId.' AND (published=1 OR payment_method="os_offline")' ; 
			$db->setQuery($sql) ;
			$numberRegistrants = (int)$db->loadResult();
			if ($numberRegistrants >= $row->event_capacity)
				return false ;	
		}		
		//Check to see whether the current user has registered for the event
		$preventDuplicateRegistration = EventBookingHelper::getConfigValue('prevent_duplicate_registration') ;
		if ($preventDuplicateRegistration && $user->get('id')) {
			$sql = 'SELECT COUNT(id) FROM #__eb_registrants WHERE event_id='.$eventId.' AND user_id='.$user->get('id').' AND (published=1 OR payment_method="os_offline")';
			$db->setQuery($sql) ;
			$total = $db->loadResult();
			if ($total) {
				return false ;	
			}	
		}		
		return true ;	
	}
	/**
	 * Get total registrants
	 *
	 */
	function getTotalRegistrants($eventId) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT SUM(number_registrants) AS total_registrants FROM #__eb_registrants WHERE event_id='.$eventId.' AND (published=1 OR payment_method="os_offline")' ; 
		$db->setQuery($sql) ;
		$numberRegistrants = (int)$db->loadResult();
		return $numberRegistrants ;
	}
	/**
	 * Get registration rate for group registration
	 *
	 * @param int $eventId
	 * @param int $numberRegistrants
	 * @return 
	 */
	function getRegistrationRate($eventId, $numberRegistrants) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT price FROM #__eb_event_group_prices WHERE event_id='.$eventId.' AND registrant_number <= '.$numberRegistrants.' ORDER BY registrant_number DESC LIMIT 1';
		$db->setQuery($sql) ;
		$rate = $db->loadResult();				
		if (!$rate) {
			$sql = 'SELECT individual_price FROM #__eb_events WHERE id='.$eventId;
			$db->setQuery($sql) ;
			$rate = $db->loadResult();
		}				
		return $rate ;
	}	
	/**
	 * Check to see whether the ideal payment plugin installed and activated
	 * @return boolean	 
	 */
	function idealEnabled() {
		$db = & JFactory::getDBO();
		$sql = 'SELECT COUNT(id) FROM #__eb_payment_plugins WHERE name="os_ideal" AND published=1';
		$db->setQuery($sql) ;
		$total = $db->loadResult() ;
		if ($total) {
			require_once JPATH_COMPONENT.DS.'payments'.DS.'ideal'.DS.'ideal.class.php';
			return true ;
		} else {
			return false ;	
		}			
	}
	/**	 
	 * Get list of banks for ideal payment plugin
	 * @return array
	 */
	function getBankLists() {		
		$idealPlugin = os_payments::loadPaymentMethod('os_ideal');
		$params = new JParameter($idealPlugin->params) ;
		$partnerId = $params->get('partner_id');
		$ideal = new iDEAL_Payment($partnerId) ;
		$bankLists = $ideal->getBanks();
		return $bankLists ;
	}
	/**
	 * Payment success. 
	 *
	 * @param object $row
	 */
	function paymentSuccess($row) {
		$config = EventBookingHelper::getConfig() ;		
		$row->payment_date =  date('Y-m-d H:i:s');
		$row->published = true;
		$row->store();						
		EventBookingHelper::sendEmails($row, $config);	
		JPluginHelper::importPlugin( 'eventbooking' );
		$dispatcher =& JDispatcher::getInstance();
		$dispatcher->trigger( 'onAfterPaymentSuccess', array($row));
	}
	/**
	 * Helper function for sending emails to registrants and administrator
	 *
	 * @param RegistrantEventBooking $row
	 * @param object $config
	 */		
	function sendEmails($row, $config) {		
		$jconfig = new JConfig();				
		$db = & JFactory::getDBO();			
		if ($config->from_name)
			$fromName = $config->from_name ;
		else 
			$fromName = $jconfig->fromname ;
		if ($config->from_email)
			$fromEmail = $config->from_email ;
		else			
			$fromEmail =  $jconfig->mailfrom ;				
		$sql = "SELECT * FROM #__eb_events WHERE id=".$row->event_id ;
		$db->setQuery($sql) ;
		$event = $db->loadObject();
		$params = new JParameter($event->params) ;
		$keys = array('s_lastname', 's_organization', 's_address', 's_address2', 's_city', 's_state', 's_zip', 's_country', 's_phone', 's_fax', 's_comment');
		foreach ($keys as $key) {
			$config->$key = $params->get($key, 0) ;
		}				
		//Need to over-ridde some config options				
		$emailContent = EventBookingHelper::getEmailContent($config, $row);
		if ($config->multiple_booking) {
			$sql = 'SELECT event_id FROM #__eb_registrants WHERE id='.$row->id.' OR cart_id='.$row->id.' ORDER BY id' ;
			$db->setQuery($sql) ;
			$eventIds = $db->loadResultArray();
			$sql = 'SELECT title FROM #__eb_events WHERE id IN ('.implode(',', $eventIds).') ORDER BY FIND_IN_SET(id, "'.implode(',', $eventIds).'")';
			$db->setQuery($sql) ;
			$eventTitles = $db->loadResultArray();
			$eventTitle = implode(', ', $eventTitles) ;						
		} else {
			$sql = 'SELECT title FROM #__eb_events WHERE id='.$row->event_id ;
			$db->setQuery($sql) ;
			$eventTitle = $db->loadResult();	
		}			
		$replaces = array() ;		
		$replaces['event_title'] = $eventTitle ;				
		$replaces['first_name'] = $row->first_name ;
		$replaces['last_name'] = $row->last_name ;
		$replaces['organization'] = $row->organization ;
		$replaces['address'] = $row->address ;
		$replaces['address2'] = $row->address ;
		$replaces['city'] = $row->city ;
		$replaces['state'] = $row->state ;
		$replaces['zip'] = $row->zip ;
		$replaces['country'] = $row->country ;
		$replaces['phone'] = $row->phone ;
		$replaces['fax'] = $row->phone ;
		$replaces['email'] = $row->email ;
		$replaces['comment'] = $row->comment ;
		$replaces['amount'] = number_format($row->amount, 2) ;
		//Override config messages
		$sql = 'SELECT * FROM #__eb_events WHERE id='.$row->event_id ;
		$db->setQuery($sql) ;
		$rowEvent = $db->loadObject();
		if ($rowEvent) {			
			if (strlen(trim(strip_tags($rowEvent->user_email_body)))) {
				$config->user_email_body = $rowEvent->user_email_body ;
			}
			if (strlen(trim(strip_tags($rowEvent->user_email_body_offline)))) {
				$config->user_email_body_offline = $rowEvent->user_email_body_offline ;
			}			
		}		
		//Notification email send to user
		$subject = $config->user_email_subject;
		if ($row->payment_method == 'os_offline') {
			$body = $config->user_email_body_offline ;
		} else {			
			$body = $config->user_email_body ;	
		}			
		$subject = str_replace('[EVENT_TITLE]', $eventTitle, $subject) ;
		$body = str_replace('[REGISTRATION_DETAIL]', $emailContent, $body) ;
		foreach ($replaces as $key=>$value) {
			$key = strtoupper($key) ;
			$body = str_replace("[$key]", $value, $body) ;
		}																				
		JUtility::sendMail($fromEmail, $fromName, $row->email, $subject, $body, 1);				
		//Send emails to notification emails
		if (strlen(trim($event->notification_emails)) > 0)
			$config->notification_emails = $event->notification_emails ;
		if ($config->notification_emails == '')	
			$notificationEmails = $fromEmail;
		else 
			$notificationEmails = $config->notification_emails;
		$notificationEmails = str_replace(' ', '', $notificationEmails);
		$emails = explode(',', $notificationEmails);				
		$subject = $config->admin_email_subject ;
		$subject = str_replace('[EVENT_TITLE]', $eventTitle, $subject) ;
		$body = $config->admin_email_body ;		
		$body = str_replace('[REGISTRATION_DETAIL]', $emailContent, $body);
		foreach ($replaces as $key=>$value) {
			$key = strtoupper($key) ;
			$body = str_replace("[$key]", $value, $body) ;
		}
		for ($i = 0, $n  = count($emails); $i < $n ; $i++) {
			$email = $emails[$i];
			JUtility::sendMail($fromEmail, $fromName, $email, $subject, $body, 1);					
		}												
	}	
	/**
	 * Get country code
	 *
	 * @param string $countryName
	 * @return string
	 */
	function getCountryCode($countryName) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT country_2_code FROM #__eb_countries WHERE LOWER(name)="'.JString::strtolower($countryName).'"';
		$db->setQuery($sql) ;
		$countryCode = $db->loadResult();
		if (!$countryCode)
			$countryCode = 'US' ;
		return $countryCode ;		
	}
	/**
	 * Display copy right information
	 *
	 */
	function displayCopyRight() {
		global $eb_version ;
		echo '<div class="copyright" style="text-align:center;margin-top: 5px;"><a href="http://joomdonation.com/index.php?option=com_content&view=article&id=79&Itemid=58" target="_blank"><strong>Event Booking</strong></a> version '.$eb_version.', Copyright (C) 2010 <a href="http://joomdonation.com" target="_blank"><strong>Ossolution Team</strong></a></div>' ;
	}
	/**
	 * Calcuate total discount for the registration
	 * @return decimal
	 */		
	function calcuateDiscount() {
		return 10 ;	
	}	
	/**
	 * Check category access
	 *
	 * @param int $categoryId
	 */
	function checkCategoryAccess($categoryId) {
		global $mainframe ,  $Itemid ;
		$user = & JFactory::getUser() ;
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT `access` FROM #__eb_categories WHERE id='.$categoryId ;
		$db->setQuery($sql) ;
		$access = (int)$db->loadResult();
		if ($user->get('aid') < $access) {
			$mainframe->redirect('index.php?option=com_eventbooking&Itemid='.$Itemid, JText::_('NOT_AUTHORIZED'));		
		}
	}
	/**
	 * Check to see whether the current user can 
	 *
	 * @param int $eventId
	 */	
	function checkEventAccess($eventId) {
		global $mainframe ,  $Itemid ;
		$db = & JFactory::getDBO() ;
		$user = & JFactory::getUser() ;
		$sql = 'SELECT `access` FROM #__eb_events WHERE id='.$eventId ;
		$db->setQuery($sql) ;
		$access = (int)$db->loadResult();
		if ($user->get('aid') < $access) {
			$mainframe->redirect('index.php?option=com_eventbooking&Itemid='.$Itemid, JText::_('NOT_AUTHORIZED'));		
		}	
	}	
	/**
	 * Check to see whether a users to access to registration history
	 * Enter description here
	 */
	function checkAccessHistory() {
		global $mainframe, $Itemid ;
		$user = & JFactory::getUser();
		if (!$user->get('id')) {
			$mainframe->redirect('index.php?option=com_eventbooking&Itemid='.$Itemid, JText::_('NOT_AUTHORIZED'));
		}
	}
	/**
	 * 
	 * Check the access to registrants history from frontend
	 */
	function checkRegistrantsAccess() {
		global $mainframe, $Itemid ;
		$registrantAccessUserIds = EventBookingHelper::getConfigValue('registrant_access_user_ids');
		$user = & JFactory::getUser() ;
		$registrantAccessUserIds = explode(',', $registrantAccessUserIds) ; 
		if (!in_array($user->get('id'), $registrantAccessUserIds)) {
			$mainframe->redirect('index.php?option=com_eventbooking&Itemid='.$Itemid, JText::_('NOT_AUTHORIZED'));
		}
	}
	/**
	 * 
	 * Check to see whether this users has permission to edit registrant
	 */
	function checkEditRegistrant() {		
		global $mainframe, $Itemid ;		
		$db = & JFactory::getDBO();
		$cid = Jrequest::getVar('cid', array()) ; 
		$registrantId = (int)$cid[0] ;
		$canAccess = true ;
		if (!$registrantId)
			$canAccess = false ;			
		$registrantAccessUserIds = EventBookingHelper::getConfigValue('registrant_access_user_ids');
		$user = & JFactory::getUser() ;
		$registrantAccessUserIds = explode(',', $registrantAccessUserIds) ;
		$sql = 'SELECT user_id, email FROM #__eb_registrants WHERE id='.$registrantId ;
		$db->setQuery($sql) ;
		$rowRegistrant = $db->loadObject();						
		if (in_array($user->get('id'), $registrantAccessUserIds) || ($user->get('id') == $rowRegistrant->user_id) || ($user->get('email') == $rowRegistrant->email)) {
			$canAccess = true ;	
		} else {
			$canAccess = false ;
		}
		if (!$canAccess) {
			$mainframe->redirect('index.php?option=com_eventbooking&Itemid='.$Itemid, JText::_('NOT_AUTHORIZED'));	
		}									
	}	
	/**
	 * Check to see whether this event can be cancelled	 
	 * @param int $eventId
	 */
	function canCancel($eventId) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT COUNT(*) FROM #__eb_events WHERE enable_cancel_registration = 1 AND (DATEDIFF(cancel_before_date, NOW()) >=0) ';
		$db->setQuery($sql) ;
		$total = $db->loadResult() ;
		if ($total)		
			return true ;
		else
			return false ;			
	}	
	/**
	 * Create a user account	 
	 * @param array $data
	 * @return int Id of created user
	 */
	function saveRegistration($data) {
		$user 		= clone(JFactory::getUser());				
		$authorize	=& JFactory::getACL();
		$data['password2'] = $data['password'] ;
		$data['name'] = $data['first_name'].' '.$data['last_name'] ;
		// If user registration is not allowed, show 403 not authorized.
		$usersConfig = &JComponentHelper::getParams( 'com_users' );
		if ($usersConfig->get('allowUserRegistration') == '0') {
			JError::raiseError( 403, JText::_( 'Access Forbidden' ));
			return false;			
		}
		// Initialize new usertype setting
		$newUsertype = $usersConfig->get( 'new_usertype' );
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}

		// Bind the post array to the user object
		if (!$user->bind( $data, 'usertype' )) {
			JError::raiseError( 500, $user->getError());
		}

		// Set some initial user values
		$user->set('id', 0);
		$user->set('usertype', $newUsertype);
		$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));

		$date =& JFactory::getDate();
		$user->set('registerDate', $date->toMySQL());						
		if ( !$user->save() )
		{
			JError::raiseWarning('', JText::_( $user->getError()));
			return false;						
		}
		//Add support for CB integration		
		$integration = EventBookingHelper::getConfigValue('cb_integration') ;
		if ($integration == 1) {				
			$db = & JFactory::getDBO() ;
			$config = EventBookingHelper::getConfig() ;
			//We need to get all fields from CB
			$sql = ' SHOW FIELDS FROM #__comprofiler ';
			$db->setQuery($sql) ;
			$rows = $db->loadObjectList();
			$fields = array();			
			for ($i = 0 , $n = count($rows); $i < $n; $i++) {
				$row = $rows[$i];
				$fields[] = $row->Field; 				
			}
			$fieldMapping = array() ;
			$rowProfile = new stdClass() ;			
			//Get the core field
			$basicFields = array('first_name'=>'m_firstname', 
								 'last_name' => 'm_lastname',
								 'organization' => 'm_organization',
								 'address' => 'm_address',
								 'address2' => 'm_address2',
								 'city' => 'm_city',
								 'state' => 'm_state',
								 'zip' => 'm_zip',
								 'country' => 'm_country',
								 'phone' => 'm_phone',																	 
								 'fax' => 'm_fax' 						
								) ;
			foreach ($basicFields as $coreField => $basicField) {
				$field = $config->$basicField ;
				if($field && in_array($field, $fields)) {
					$rowProfile->$field = JRequest::getVar($coreField, 'post', '');
				}	
			}
			$userId = $user->get('id');
			$rowProfile->approved = 1 ;
			$rowProfile->confirmed = 1 ;
			$rowProfile->id = $userId ;
			$rowProfile->user_id = $userId ;										
			//Insert this user into database						
			$db->insertObject('#__comprofiler', $rowProfile, 'id') ;
		}
		return $user->get('id');		
	}		
	/**
	 * Get list of recurring event dates
	 * @param DateTime $startDate
	 * @param DateTime $endDate
	 * @param int $dailyFrequency
	 * @param int $numberOccurencies
	 * @return array
	 */	
	function getDailyRecurringEventDates($startDate, $endDate, $dailyFrequency, $numberOccurencies) {
		$eventDates = array() ;
		$eventDates[] = $startDate ;
		//Convert to unix timestamp for easili maintenance
		$startTime = strtotime($startDate) ;			
		$endTime = strtotime($endDate.' 23:59:59') ;			
		if ($numberOccurencies) {
			$count = 1 ;
			$i = 1 ;
			while ($count < $numberOccurencies) {
				$i++ ;
				$count++ ;
				$nextEventDate = $startTime + ($i-1)*$dailyFrequency*24*3600 ;							
				$eventDates[] = strftime('%Y-%m-%d %H:%M:%S', $nextEventDate) ;				
			}			
		} else {
			$i = 1 ;
			while (true) {
				$i++ ;
				$nextEventDate = $startTime + ($i -1)*24*$dailyFrequency*3600 ;
				if ($nextEventDate <= $endTime) {					 				
					$eventDates[] = strftime('%Y-%m-%d %H:%M:%S', $nextEventDate) ;
				} else {
					break ;
				}	
			}			
		}			
		return $eventDates ;	
	}
	/**
	 * Get weekly recurring event dates
	 * @param DateTime $startDate
	 * @param DateTime $endDate
	 * @param Int $weeklyFrequency
	 * @param int $numberOccurrencies
	 * @param array $weekDays
	 * @return array
	 */
	function getWeeklyRecurringEventDates($startDate,  $endDate, $weeklyFrequency, $numberOccurrencies, $weekDays) {
		$eventDates = array() ;				
		$startTime = strtotime($startDate) ;	
		$originalStartTime = $startTime ;
		$endTime = strtotime($endDate.' 23:59:59') ;
		if ($numberOccurrencies) {
			$count = 0 ;
			$i = 0 ;
			$weekDay =  date('w', $startTime) ;
			$startTime = $startTime - $weekDay*24*3600 ;			
			while ($count < $numberOccurrencies) {				
				$i++ ;
				$startWeekTime = $startTime + ($i -1)*$weeklyFrequency*7*24*3600 ;														 						
				foreach ($weekDays as $weekDay) {
					$nextEventDate = $startWeekTime + $weekDay*24*3600 ;
					if (($nextEventDate >= $originalStartTime) && ($count < $numberOccurrencies)) {
						$eventDates[] = strftime('%Y-%m-%d %H:%M:%S', $nextEventDate) ;
						$count++ ;
					}						
				}
			}						
		} else {
			$weekDay =  date('w', $startTime) ;
			$startTime = $startTime - $weekDay*24*3600 ;
			while ($startTime < $endTime) {
				foreach ($weekDays as $weekDay) {
					$nextEventDate = $startTime + $weekDay*24*3600 ; ;
					if ($nextEventDate < $originalStartTime)
						continue ;					
					if ($nextEventDate <= $endTime) {
						$eventDates[] = strftime('%Y-%m-%d %H:%M:%S', $nextEventDate) ;
					} else {
						break ;
					}					
				}
				$startTime += $weeklyFrequency*7*24*3600 ;				
			}					
		}			
		return $eventDates ;	
	}
	/**
	 * Get list of monthly recurring
	 * @param DateTime $startDate
	 * @param DateTime $endDate
	 * @param int $monthlyFrequency
	 * @param int $numberOccurrencies
	 * @param string $monthDays
	 * @return array
	 */
	function getMonthlyRecurringEventDates($startDate, $endDate, $monthlyFrequency, $numberOccurrencies, $monthDays) {
		$eventDates = array() ;				
		$startTime = strtotime($startDate) ;
		$hour = date('H', $startTime);
		$minute = date('i', $startTime) ;	
		$originalStartTime = $startTime ;
		$endTime = strtotime($endDate.' 23:59:59') ;		
		$monthDays = explode(',', $monthDays) ;
		if ($numberOccurrencies) {
			$count = 0 ;
			$currentMonth = date('m', $startTime) ;
			$currentYear = date('Y', $startTime) ;		
			while($count < $numberOccurrencies) {
				foreach ($monthDays as $day) {
					$nextEventDate = mktime($hour, $minute, 0, $currentMonth, $day, $currentYear); 
					if (($nextEventDate >= $originalStartTime) && ($count < $numberOccurrencies)) {
						$eventDates[] = strftime('%Y-%m-%d %H:%M:%S', $nextEventDate) ;
						$count++ ;
					}
				}
				$currentMonth += $monthlyFrequency ;
				if ($currentMonth > 12) {
					$currentMonth -= 12 ;
					$currentYear++ ;
				}
			}						
		} else {						
			$currentMonth = date('m', $startTime) ;
			$currentYear = date('Y', $startTime) ;
			while ($startTime < $endTime) {							
				foreach ($monthDays as $day) {
					$nextEventDate = mktime($hour, $minute, 0, $currentMonth, $day, $currentYear); 
					if (($nextEventDate >= $originalStartTime) && ($nextEventDate <= $endTime)) {
						$eventDates[] = strftime('%Y-%m-%d %H:%M:%S', $nextEventDate) ;					
					}
				}
				$currentMonth += $monthlyFrequency ;
				if ($currentMonth > 12) {
					$currentMonth -= 12 ;
					$currentYear++ ;
				}	
				$startTime = mktime(0, 0, 0, $currentMonth, 1, $currentYear);			
			}					
		}	
		return $eventDates ;	
	}		
	function getDeliciousButton( $title, $link ) {	
		$img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/delicious.png"; 		
		return '<a href="http://del.icio.us/post?url=' . rawurlencode($link) . '&amp;title=' . rawurlencode( $title ) . '" title="Submit ' . $title . ' in Delicious" target="blank" >
		<img src="' . $img_url . '" alt="Submit ' . $title . ' in Delicious" />
		</a>' ;	
	}	
    function getDiggButton( $title, $link ) {    
        $img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/digg.png"; 
        return '<a href="http://digg.com/submit?url=' . rawurlencode($link) . '&amp;title=' . rawurlencode( $title ) . '" title="Submit ' . $title . ' in Digg" target="blank" >
        <img src="' . $img_url . '" alt="Submit ' . $title . ' in Digg" />
        </a>' ;   
    }
    function getFacebookButton( $title, $link ) {    
        $img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/facebook.png";         
        return '<a href="http://www.facebook.com/sharer.php?u=' . rawurlencode($link) . '&amp;t=' . rawurlencode( $title ) . '" title="Submit ' . $title . ' in FaceBook" target="blank" >
        <img src="' . $img_url . '" alt="Submit ' . $title . ' in FaceBook" />
        </a>' ;    
    }    
    function getGoogleButton( $title, $link ) {    
        $img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/google.png";         
        return '<a href="http://www.google.com/bookmarks/mark?op=edit&bkmk=' . rawurlencode($link) . '" title="Submit ' . $title . ' in Google Bookmarks" target="blank" >
        <img src="' . $img_url . '" alt="Submit ' . $title . ' in Google Bookmarks" />
        </a>' ;    
    }    
    function getStumbleuponButton( $title, $link ) {    
        $img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/stumbleupon.png";         
        return '<a href="http://www.stumbleupon.com/submit?url=' . rawurlencode($link) . '&amp;title=' . rawurlencode( $title ) . '" title="Submit ' . $title . ' in Stumbleupon" target="blank" >
        <img src="' . $img_url . '" alt="Submit ' . $title . ' in Stumbleupon" />
        </a>' ;    
    }    
    function getTechnoratiButton( $title, $link ) {    
        $img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/technorati.png";         
        return '<a href="http://technorati.com/faves?add=' . rawurlencode($link) . '" title="Submit ' . $title . ' in Technorati" target="blank" >
        <img src="' . $img_url . '" alt="Submit ' . $title . ' in Technorati" />
        </a>' ;
    }    
    function getTwitterButton( $title, $link ) {    
        $img_url = JURI::base()."/components/com_eventbooking/assets/images/socials/twitter.png";         
        return '<a href="http://twitter.com/?status=' . rawurlencode( $title ." ". $link ) . '" title="Submit ' . $title . ' in Twitter" target="blank" >
        <img src="' . $img_url . '" alt="Submit ' . $title . ' in Twitter" />
        </a>' ;    
    }		
}
?>